precision highp float;

uniform mat4 u_m44ModelViewProjection;
uniform vec3 u_v3LightDir;
uniform mat3 u_m33SpecularRotation;

#ifdef SPOT_LIGHT
uniform vec3 u_v3ObjectPosition;
#endif

attribute vec4 a_v4Position;
attribute vec2 a_v2TexCoord;
attribute vec2 a_v2TexCoord3;
attribute vec3 a_v3Normal;

varying highp vec4 v_v4ShadowMapPosition;
varying highp vec2 v_v2TexCoordLightmap;
varying lowp vec3 v_v3Normal;
varying vec3 v_v3LightDir;

void main() 
{
	v_v3Normal = a_v3Normal * u_m33SpecularRotation;
	v_v2TexCoordLightmap = a_v2TexCoord3;
#ifdef SPOT_LIGHT
	v_v4ShadowMapPosition = (u_m44ModelViewProjection * a_v4Position);
	v_v4ShadowMapPosition /= v_v4ShadowMapPosition.w;
	v_v4ShadowMapPosition = ((v_v4ShadowMapPosition * 0.5) + 0.5);
#else
	v_v4ShadowMapPosition = ((u_m44ModelViewProjection * a_v4Position) * 0.5) + 0.5;
#endif

#ifdef SPOT_LIGHT
	v_v3LightDir = normalize(((a_v4Position.xyz * u_m33SpecularRotation) + u_v3ObjectPosition) - u_v3LightDir);
#else
	v_v3LightDir = normalize(u_v3LightDir);
#endif

	gl_Position = vec4((v_v2TexCoordLightmap.x - 0.5) * 2.0, (v_v2TexCoordLightmap.y - 0.5) * 2.0, 0.0, 1.0);
}

