precision highp float;

uniform mat4 u_m44ModelViewProjection;
uniform vec3 u_v3LightDir;
uniform mat3 u_m33SpecularRotation;

attribute vec4 a_v4Position;
attribute vec2 a_v2TexCoord;
attribute vec2 a_v2TexCoord3;
attribute vec3 a_v3Normal;

varying highp vec2 v_v2TexCoordLightmap;
varying lowp vec3 v_v3Normal;
varying vec3 v_v3LightDir;

void main() 
{
	v_v3Normal = a_v3Normal * u_m33SpecularRotation;
	v_v2TexCoordLightmap = a_v2TexCoord3;

	v_v3LightDir = normalize(u_v3LightDir);

	gl_Position = vec4((v_v2TexCoordLightmap.x - 0.5) * 2.0, (v_v2TexCoordLightmap.y - 0.5) * 2.0, 0.0, 1.0);
}

