
uniform lowp sampler2D tex1;
uniform lowp sampler2D tex2;
uniform lowp sampler2D tex3;
uniform lowp float inverseTexSizeU;
uniform lowp float inverseTexSizeV;

varying mediump vec2 v_v2TexCoord;
varying mediump vec2 v_v2TexCoord2;

void main() 
{
	lowp vec3 diffuse = texture2D(tex3, v_v2TexCoord).rgb;
	lowp float mask = texture2D(tex2, v_v2TexCoord).r;	
	if(mask < 0.5)
	{
		mediump float gamma = 8.0;
		lowp vec3 brightness = pow(diffuse, vec3(gamma, gamma, gamma));
		lowp float lum = (brightness.r * 0.2126 + brightness.g * 0.7152 + brightness.b * 0.0722);

		if(lum < 0.05)
		{
			lowp float s01 = texture2D(tex1, v_v2TexCoord2 + vec2(-1.0, 0.0) * inverseTexSizeU).x;
			lowp float s21 = texture2D(tex1, v_v2TexCoord2 + vec2(1.0, 0.0) * inverseTexSizeU).x;
			lowp float s10 = texture2D(tex1, v_v2TexCoord2 + vec2(0.0, -1.0) * inverseTexSizeV).x;
			lowp float s12 = texture2D(tex1, v_v2TexCoord2 + vec2(0.0, 1.0) * inverseTexSizeV).x;

			lowp vec3 va = normalize(vec3(0.3, 0.0, s21 - s01));
			lowp vec3 vb = normalize(vec3(0.0, 0.3, s12 - s10));

			lowp vec3 BumpNormal = cross(va, vb);

			lowp float NdotL = max(0.0, dot(BumpNormal, vec3(0.0, 0.0 , 1.0)));
			diffuse *= NdotL;

			if(NdotL > 0.0)
			{
				lowp vec3 reflection = reflect(vec3(0.0, 0.0, 1.0), BumpNormal);
				lowp float specular = max(0.0, dot(reflection, vec3(0.0, 0.25, 0.75)));
				diffuse += pow(specular, 1.3);
			}
		}
	}
	gl_FragColor.rgb = diffuse;
}