
uniform lowp sampler2D tex1;
uniform lowp sampler2D tex2;
uniform lowp sampler2D tex3;
uniform lowp sampler2D tex4;

varying mediump vec2 v_v2TexCoord;
varying mediump vec2 v_v2TexCoord2;

void main() 
{
	lowp float diffuse = texture2D(tex1, v_v2TexCoord2).r;
	lowp float mask = texture2D(tex2, v_v2TexCoord).r;
	diffuse *= 0.6;	

	lowp vec3 luminosity = texture2D(tex3, v_v2TexCoord).rgb;
	mediump float gamma = 8.0;
	lowp vec3 brightness = pow(luminosity, vec3(gamma, gamma, gamma));
	lowp float lum = (brightness.r * 0.2126 + brightness.g * 0.7152 + brightness.b * 0.0722);

	if(lum >= 0.05)
	{
		diffuse *= 0.5;
	}

	if(mask >= 0.5)
	{
		diffuse = 0.15;
	}
	lowp vec4 WearSpecAo = texture2D(tex4, gl_FragCoord.xy / 512.0);
	WearSpecAo.r = diffuse;
	gl_FragColor = WearSpecAo;
}
