
uniform lowp sampler2D tex1;
uniform lowp sampler2D tex2;
uniform lowp sampler2D tex3;
uniform lowp float inverseTexSizeU;
uniform lowp float inverseTexSizeV;

varying mediump vec2 v_v2TexCoord;
varying mediump vec2 v_v2TexCoord2;
varying lowp vec3 v_v3Normals;
varying lowp vec3 v_v3Tangents;

void main() 
{
	lowp vec3 Normal = normalize(v_v3Normals);
	lowp float mask = texture2D(tex2, v_v2TexCoord).r;	
	if(mask < 0.5)
	{
		lowp vec3 diffuse = texture2D(tex3, v_v2TexCoord).rgb;
		mediump float gamma = 8.0;
		lowp vec3 brightness = pow(diffuse, vec3(gamma, gamma, gamma));
		lowp float lum = (brightness.r * 0.2126 + brightness.g * 0.7152 + brightness.b * 0.0722);

		lowp vec3 Tangent = normalize(v_v3Tangents);
		Tangent = normalize(Tangent - dot(Tangent, Normal) * Normal);
		lowp vec3 BiTangent = cross(Tangent, Normal);
		lowp mat3 TBN = mat3(Tangent, BiTangent, Normal);

		lowp float s01 = texture2D(tex1, v_v2TexCoord2 + vec2(-1.0, 0.0) * inverseTexSizeU).x;
		lowp float s21 = texture2D(tex1, v_v2TexCoord2 + vec2(1.0, 0.0) * inverseTexSizeU).x;
		lowp float s10 = texture2D(tex1, v_v2TexCoord2 + vec2(0.0, -1.0) * inverseTexSizeV).x;
		lowp float s12 = texture2D(tex1, v_v2TexCoord2 + vec2(0.0, 1.0) * inverseTexSizeV).x;

		lowp vec3 va;
		lowp vec3 vb;
		if(lum < 0.05)
		{
			va = normalize(vec3(0.4, 0.0, s21 - s01));
			vb = normalize(vec3(0.0, 0.4, s12 - s10));
		}
		else
		{
			va = normalize(vec3(0.9, 0.0, s21 - s01));
			vb = normalize(vec3(0.0, 0.9, s12 - s10));
		}
		lowp vec3 BumpNormal = cross(va, vb);

		Normal = TBN * BumpNormal;
		Normal = normalize(Normal);
	}
	gl_FragColor.rgb = (Normal * 0.5 + 0.5).rbg;
}
