uniform mat4 u_m44ModelViewProjection;
uniform mat4 u_m44Texture;

attribute vec4 a_v4Position;
attribute vec2 a_v2TexCoord;
attribute vec2 a_v2TexCoord2;

attribute vec3 a_v3MatrixX;
attribute vec3 a_v3MatrixY;

varying mediump vec2 v_v2TexCoord;
varying mediump vec2 v_v2TexCoord2;
varying lowp vec3 v_v3Normals;
varying lowp vec3 v_v3Tangents;

void main() 
{
	// The grip was UV mapped upside down... the original map was noise so it was probably hard to tell. Just rotate the UVs in the shader and all works with screen grabs correctly
	v_v2TexCoord = (u_m44Texture * vec4(a_v2TexCoord, 0, 1)).xy;
	v_v2TexCoord += 0.5;
	v_v2TexCoord2 = a_v2TexCoord2;
	v_v2TexCoord2.x *= 2.0;
	v_v2TexCoord2.y *= 4.0;
	v_v3Normals = a_v3MatrixX;
	v_v3Tangents = a_v3MatrixY;

	gl_Position = u_m44ModelViewProjection * a_v4Position;
}

