precision lowp float;

uniform samplerCube tex3;
uniform sampler2D tex1;
uniform sampler2D tex2;
uniform sampler2D tex4;
//uniform sampler2D tex5;
//uniform sampler2D tex6;
uniform sampler2D tex7;

varying vec2 v_v2TexCoord;
varying vec3 v_v3WorldPosition;
varying vec2 v_v2WearUV;

uniform mat3 u_m33NormalTransform;
uniform vec4 u_v4Color;
uniform vec3 u_v3LightDir;
uniform vec3 u_v3EyePosition;
uniform float u_fBrightness;	
uniform vec3 u_v3WearColour;

void main() 
{	
	vec3 v3TextureNormal = texture2D(tex1, v_v2TexCoord).rgb; 
	vec3 v3TextureDiffuse = texture2D(tex2, v_v2TexCoord).rgb;
	vec3 v3TextureWearSpecAo = texture2D(tex7, v_v2TexCoord).rgb; // r contains specular, g contains wear, b contains ambient oclusion
	

	//v3TextureNormal.w = v4TextureWearPattern.r;
	//v3TextureDiffuse.w = v4TextureWearPattern.b;
		
	// todo: Is there a way to pre transform to avoid multiplying by u_m33NormalTransform during the fragment shader?
	// todo: I think it might require the cube map to be rotated, which wont work for different car body parts.
	// todo: It is an expensive per pixel operation so it would be nice to avoid it.
	vec3 v3Incident = v_v3WorldPosition - u_v3EyePosition;
	vec3 v3Normal = (2.0 * (v3TextureNormal.xyz - vec3(0.5, 0.5, 0.5))) * u_m33NormalTransform;
	v3Incident = reflect(v3Incident, v3Normal);	

	vec4 v4TextureCube = textureCube(tex3, v3Incident);
	



	vec4 v4TextureWear = texture2D(tex4, v_v2WearUV);	
	
	 
	vec4 v4Wear = vec4(u_v3WearColour, (v3TextureWearSpecAo.g - 1.0) / (0.001 + v4TextureWear.r) + 1.0);
	v4Wear.a = clamp(v4Wear.a, 0.0, 1.0);
	
	float fA = clamp((1.0 - v4Wear.a * 1.5), 0.0, 1.5);

	v3TextureDiffuse.xyz = (v4Wear.rgb * v4Wear.a * v4Wear.a) + (v3TextureDiffuse.xyz * fA);
	//v3TextureWearSpecAo.r *= 1.0 - v4Wear.a;
	v3TextureWearSpecAo.r *= fA;


	gl_FragColor.xyz = 
		v4TextureCube.xyz * v3TextureWearSpecAo.r * v3TextureWearSpecAo.b * 1.5 + 
		v3TextureDiffuse.xyz * (dot(v3Normal, u_v3LightDir) + 1.5) * u_v4Color.xyz * v3TextureWearSpecAo.b;

	
	
	//gl_FragColor.rgb = v3TextureWearSpecAo.rgb;
				
	vec3 v3Tmp = 1.0 - gl_FragColor.rgb;

	gl_FragColor.rgb = gl_FragColor.rgb * (2.0 - u_fBrightness) + (1.0 - v3Tmp * v3Tmp * v3Tmp) * (u_fBrightness - 1.0);

//	gl_FragColor.rgb = v3TextureNormal.rgb;
	
	gl_FragColor.w = 0.25;
}
