
uniform sampler2D tex;
uniform lowp vec4 u_v4Color;

varying mediump vec2 v_v2TexCoord;
varying highp vec2 v_v2WearAndRandSeed;

highp float rand(highp vec2 co)
{
    highp float a = 12.9898;
    highp float b = 78.233;
    highp float c = 43758.5453;
    highp float dt= dot(co.xy ,vec2(a,b));
    highp float sn= mod(dt,3.14);
    
    return fract(sin(sn) * c);
}

void main() 
{
	mediump float fTotalWear = texture2D(tex, v_v2TexCoord).r * v_v2WearAndRandSeed.x;
    mediump float fRand = rand(vec2(gl_FragCoord.x * cos(v_v2WearAndRandSeed.y), gl_FragCoord.y * sin(v_v2WearAndRandSeed.y)));
    mediump float fWear = v_v2WearAndRandSeed.x - (fTotalWear + (fTotalWear * 0.25));
    fRand = step(fRand, fWear);
    gl_FragColor.rgb = u_v4Color.rgb * fRand;
}