precision highp float;

uniform sampler2D tex_d;
uniform sampler2D tex_n;
uniform sampler2D tex_g_ao_a;

uniform float u_fBrightness;
uniform vec3 u_v3LightDiffuse;
uniform vec3 u_v3LightAmbientSky;
uniform vec3 u_v3LightAmbientWater;

uniform vec3 u_v3Specular;
uniform float u_fSpecMultiplier;
uniform float u_fFadeScale;
uniform float u_fFadeAmmountX;


uniform vec3 u_v3Diffuse0;
uniform vec3 u_v3Diffuse1;
uniform vec3 u_v3Ambient0;
uniform vec3 u_v3Ambient1;

uniform vec3 u_v3SkinColour;
uniform vec3 u_v3BaseSkinColour;

//uniform float u_fFadeOffset;

varying vec3 v_v3Normal;
varying vec2 v_v2TexCoord;

#ifdef CUBE_MAP
uniform vec3 u_v3LightDir;
varying highp vec3 v_v3MatrixX;
varying highp vec3 v_v3MatrixY;
varying highp vec3 v_v3MatrixZ;
uniform samplerCube tex_c;
#else
varying highp vec3 v_v3Light_Transformed;
varying vec3 v_v3Up;
#endif

varying vec3 v_v3ViewDir;

varying vec4 v_v4Colour;
varying vec3 v_v3PositionForFade;
varying float fFadeHeight;


vec3 ToGamma(vec3 v3In)
{
	return v3In;
	//return pow(v3In, vec3(1.0/1.0));
}
vec3 FromGamma(vec3 v3In)
{
	return v3In;
	//return pow(v3In, vec3(1.0));
}

void main() 
{

	if (u_fFadeAmmountX > 0.0)
	{
		float fInvFadeLength = u_fFadeScale / length(v_v3PositionForFade.xyz);
		gl_FragColor.a = -v_v3PositionForFade.y * fInvFadeLength * 0.4 + 1.1;
		gl_FragColor.a = min(gl_FragColor.a, 1.1 - v_v3PositionForFade.x * fInvFadeLength * 0.175 * u_fFadeAmmountX);
		gl_FragColor.a = min(gl_FragColor.a, (-fFadeHeight + 70.0) * 0.1);
		//gl_FragColor.a = min(gl_FragColor.a, (gl_FragCoord.z - 0.40) * 3.0);
	}
	else 
	{
		gl_FragColor.a = 1.0;
	}

	vec3 v3TextureD = texture2D(tex_d, v_v2TexCoord).rgb;
	vec3 v3TextureG_AO_A = texture2D(tex_g_ao_a, v_v2TexCoord).rgb;
	vec3 v3TextureN = vec3(texture2D(tex_n, v_v2TexCoord.st)).rgb;

	v3TextureD *= u_v3BaseSkinColour;
	v3TextureD *= u_v3SkinColour;

#ifdef CUBE_MAP
	highp vec3 v3Normal;
	{
		highp vec3 v3NormalTmp = v3TextureN;     
		v3NormalTmp = v3TextureN;
		v3NormalTmp -= 0.5;
		v3NormalTmp *= 2.0;
		v3Normal.x = dot(v3NormalTmp, v_v3MatrixX);
		v3Normal.y = dot(v3NormalTmp, v_v3MatrixY);
		v3Normal.z = dot(v3NormalTmp, v_v3MatrixZ);
	}
	//gl_FragColor.rgb = v3Normal * 0.5 + 0.5;
	//gl_FragColor.rgb = vec3(dot(u_v3LightDir, v3Normal) * 0.5 + 0.5);

	
	vec3 v3CubeLookup = reflect(normalize(v_v3ViewDir), v3Normal);	
	/*{ // fudge it
		v3CubeLookup = mix(v3Normal, v3CubeLookup, v3TextureG_AO_A.r);
		normalize(v3Normal);
	}*/
	vec3 v3TextureCube = textureCube(tex_c, v3CubeLookup).rgb;	
	//gl_FragColor.rgb = v3TextureCube;
	
	vec3 v3TextureCubeD = textureCube(tex_c, v3Normal).rgb;	

	float fSpec = 0.05;

	fSpec += pow((1.0 - abs(dot(normalize(v_v3ViewDir), v3Normal))), 5.0) * 0.5;
		
	//gl_FragColor.xyz = 
	//	v3TextureCube * (v3TextureG_AO_A.r * v3TextureG_AO_A.b) * fSpec + 
	//	v3TextureD.xyz * ((dot(v3Normal, u_v3LightDir) * vec3(0.8)) * v3TextureG_AO_A.b + v3TextureCubeD * 0.3 + vec3(1.0)) * v_v4Colour.xyz;

	
	//gl_FragColor.xyz = 
	//	v3TextureCube * (v3TextureG_AO_A.r * v3TextureG_AO_A.g) * fSpec + 
	//	v3TextureD.xyz * (((dot(v3Normal, u_v3LightDir) * vec3(0.3, 0.6, 0.9)) + v3TextureCubeD * vec3(0.1, 0.2, 0.3) + vec3(0.6, 0.6, 0.6)) * v3TextureG_AO_A.g + vec3(.6, 0.3, 0.0)) * v_v4Colour.xyz;

	
	gl_FragColor.xyz = 
		v3TextureCube * (v3TextureG_AO_A.r * v3TextureG_AO_A.g) * fSpec + 
		v3TextureD.xyz * (((dot(v3Normal, u_v3LightDir) * u_v3Diffuse0) + v3TextureCubeD * u_v3Diffuse1 + u_v3Ambient0) * v3TextureG_AO_A.g + u_v3Ambient1) * v_v4Colour.xyz;


	
	//gl_FragColor.rgb = v3TextureWearSpecAo.rgb;
	vec3 v3Tmp = 1.0 - gl_FragColor.rgb;

	gl_FragColor.rgb = gl_FragColor.rgb * (2.0 - u_fBrightness) + (1.0 - v3Tmp * v3Tmp * v3Tmp) * (u_fBrightness - 1.0);
	gl_FragColor.a = min(gl_FragColor.a, v3TextureG_AO_A.b);



#else

    highp vec3 v3Normal = v3TextureN;    
	v3Normal = v3TextureN;
	v3Normal -= 0.5;
	v3Normal *= 2.0;

	highp float fNdotL = dot(normalize(v_v3Light_Transformed), v3Normal);
	highp float fDiffuse = fNdotL * 0.5 + 0.5;
	fDiffuse = clamp(fDiffuse, 0.02, 0.98);

	fDiffuse *= v3TextureG_AO_A.y;


	
	vec3 v3TextureTransmition = vec3(fDiffuse);
    vec3 v3ColourOut = FromGamma(v3TextureD) * v_v4Colour.rgb * mix(mix(u_v3LightAmbientWater, u_v3LightAmbientSky, dot(v_v3Up, v3Normal) * 0.5 + 0.5), u_v3LightDiffuse, v3TextureTransmition);

	float fSpec = 0.0;
	vec3 v3Reflection;
	//if (fNdotL > 0.0)
	{
		v3Reflection = normalize(reflect(v_v3ViewDir, v3Normal));
		fSpec = dot(v3Reflection, normalize(v_v3Light_Transformed));
	}
	fSpec = clamp(fSpec, 0.0, 1.0);	

	float fTextureG = v3TextureG_AO_A.x;

	fSpec = pow(fSpec, 1.0 + 5.0 * (fTextureG * u_fSpecMultiplier * 10.0) + u_fSpecMultiplier * 5.0);
	//fSpec = pow(fSpec, 1.0 + 9.0 * fTextureG);
	
	
	vec3 v3Spec = vec3(v3TextureG_AO_A.x * fSpec * u_v3Specular * u_fSpecMultiplier * 20.0) * v3TextureG_AO_A.y;
	v3ColourOut *= 1.0 - u_fSpecMultiplier * 0.25 - v3TextureG_AO_A.x * 0.25;
	v3ColourOut += v3Spec;

	gl_FragColor.xyz = ToGamma(v3ColourOut);
	gl_FragColor.a = min(gl_FragColor.a, v3TextureG_AO_A.b);

#endif

}
